﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AttackArea : MonoBehaviour {

	public Transform attackPrefab;
	public float attackRate = 2;
	float attackRateCounter = 0;

	Collider hitCollider;
	// Use this for initialization
	void Start () {
		hitCollider = GetComponent<Collider>();
		hitCollider.enabled = false;
	}
	
	// Update is called once per frame
	void FixedUpdate () {

		if ( attackRateCounter < attackRate)
		{
			attackRateCounter += Time.fixedDeltaTime;
		}

	}

	public void Activate()
	{
		if (attackRateCounter >= attackRate && attackPrefab != null)
		{
			Transform node = Instantiate(attackPrefab);
			node.position = transform.position;

			SoundBank.currentInstance.PlayExplosionSound ();
			attackRateCounter = 0;

			Destroy(node.gameObject, 3);		

			StartCoroutine(ShowHitCollider());
		}
	}

	IEnumerator ShowHitCollider()
	{
		hitCollider.enabled = true;

		yield return new WaitForSeconds(1);

		hitCollider.enabled = false;
	}
}
