﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Ball : MonoBehaviour {

	public string ballTag = "Ball";

    Rigidbody rb;
    Vector3 initPos;
    bool reset;
    public bool energy;

    float cooldown = 1;
    float cooldownCounter;

    public float returnSpeed = 5f;

    public GameObject rope;
    public Color ropeNormalColor;
    public Color ropeHoverColor;

	// Use this for initialization
	void Start () {
        rb = gameObject.GetComponent<Rigidbody>();
        reset = false;
        initPos = rb.position;
        energy = false;
	}
	
	// Update is called once per frame
	void Update () {
        if (reset) {
            rb.velocity = Vector3.zero;
            rb.angularVelocity = Vector3.zero;
            rb.position = Vector3.MoveTowards(rb.position, initPos, returnSpeed * Time.fixedDeltaTime);

            if (rb.position == initPos) {
                reset = false;
            }
        }

        if (cooldownCounter < cooldown)
        {
            cooldownCounter += Time.fixedDeltaTime;
        }

    }

	public void TouchTheBall()
	{
		Pendulum parentNode = transform.parent.GetComponent<Pendulum>();
		if ( parentNode != null)
		{
			//parentNode.activate = true;
		}
	}

    void OnMouseEnter() {
        rope.GetComponent<MeshRenderer>().material.SetColor("_TintColor", ropeHoverColor);
    }

    void OnMouseExit()
    {
        rope.GetComponent<MeshRenderer>().material.SetColor("_TintColor", ropeNormalColor);
    }

    void OnTriggerEnter(Collider other)
	{
        if (other.tag == ballTag && transform.parent != null && false)
		{
			Pendulum parentNode = transform.parent.GetComponent<Pendulum>();
			if ( parentNode != null)
			{
				Pendulum anotherPendulum = other.transform.parent.GetComponent<Pendulum>();

				if ( anotherPendulum != null)
				{

					parentNode.BallHitPendulum(anotherPendulum.transform);
                }

               
			}


		}

	}
    void OnCollisionEnter(Collision other)
    {

        reset = false;

        if (other.gameObject.tag == ballTag && transform.parent != null)
        {
            PendulumPhysics parentNode = transform.parent.GetComponent<PendulumPhysics>();

            if (parentNode != null)
            {
                if (other.gameObject.GetComponent<Ball>().energy) {

                   // other.gameObject.GetComponent<Ball>().ChangeEnergy( false);
                    //ChangeEnergy(true);
                    //parentNode.Activate(other.gameObject.GetComponent<Rigidbody>().velocity);
                    //other.gameObject.GetComponent<Ball>().ReturnToPosition();
                }

				Vector3 activatePoint = transform.position;
				if ( other.contacts.Length != 0)
				{
					activatePoint = other.contacts[0].point;
				}

				parentNode.Activate(other.gameObject.GetComponent<Rigidbody>().velocity, activatePoint);
            }

        }
    }

    public void ReturnToPosition()
    {
        rb.velocity = Vector3.zero;
        rb.angularVelocity = Vector3.zero;
        reset = true;
    }

    public void ChangeEnergy(bool energyVal) {

        if (cooldownCounter >= cooldown) { 
        cooldownCounter = 0;
        energy = energyVal;
        }


    }

}
