﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BaseEnemy : MonoBehaviour {

	WalkFollowPath walkNode;

	public int totalLifePoint = 1;
	int currentLifePoint;

    public int goldReward = 5;
    public int scoreReward = 1;

    GameManager gameManager;

	// Use this for initialization
	void Start () {
		walkNode = GetComponent<WalkFollowPath>();

		currentLifePoint = totalLifePoint;

        gameManager = GameObject.Find("Game Manager").GetComponent<GameManager>();

		SoundBank.currentInstance.PlaySpawnSound ();
	}
	
	// Update is called once per frame
	void Update () {
		
	}

	[Header("Enemy collide with this tag will decrease life point")]
	public string attackAreaTag = "AttackArea";
	void OnTriggerEnter(Collider other)
	{
		if( other.tag == attackAreaTag)
		{
			GetHit();
            
        }
	}


	void GetHit()
	{
		currentLifePoint--;
		if ( currentLifePoint <= 0)
		{
			Die();
		}
	}

	void Die()
	{
        gameManager.ChangeGold(goldReward);
        gameManager.ChangeScore(scoreReward);



        walkNode.moveSpeed = 0;
		Destroy(gameObject);
	}

}
