﻿using UnityEngine;
using System.Collections;

public class BuyNode : MonoBehaviour {

    public GameObject rope;
    public Color ropeNormalColor;
    public Color ropeHoverColor;

    public int pendulumCost = 100;

    GameManager gameManager;

    // Use this for initialization
    void Start () {
        gameManager = GameObject.Find("Game Manager").GetComponent<GameManager>();
        rope.GetComponent<MeshRenderer>().material.SetColor("_TintColor", ropeNormalColor);
    }
	
	// Update is called once per frame
	void Update () {
	
	}

    void OnMouseEnter()
    {
        if (gameManager.gold >= pendulumCost)
        {
            rope.GetComponent<MeshRenderer>().material.SetColor("_TintColor", ropeHoverColor);
        }
    }

    void OnMouseExit()
    {
        rope.GetComponent<MeshRenderer>().material.SetColor("_TintColor", ropeNormalColor);
    }

    void OnMouseDown() {

        if (gameManager.gold >= pendulumCost) {
            BuyPendulum();
        }
    }

    void BuyPendulum() {
        gameManager.ChangeGold(-pendulumCost);

        GameObject parent = transform.parent.gameObject;
        gameObject.SetActive(false);

        GameObject ball = parent.transform.Find("RockPendulum").gameObject;
        ball.SetActive(true);
        rope.GetComponent<HingeJoint>().connectedBody = ball.GetComponent<Rigidbody>();



    }
}
