﻿using UnityEngine;
using System.Collections;

public class CreepWaveSpawner : MonoBehaviour {

    public float spawnrate = 5f;
    public GameObject creep;
    public GameObject creepSpawnLocation;
    public GameObject creepNavPath;

    public int waveSize = 10;
    public float waveDelay = 10f;
    bool waveActive = false;
    public int sizeInc = 2;
    public float delayDec = 0.5f;

    int creepCount;
    float delayTimer;

    int currentWave;

    float timer;

	// Use this for initialization
	void Start () {
        timer = 0;
        currentWave = 0;

        creepCount = 0;
        delayTimer = 0;

	}
	
	// Update is called once per frame
	void Update () {

        if (waveActive)
        {
            //Spawn Creeps

            //testing
            //Original code
            //timer += Time.fixedDeltaTime * spawnrate;
            //if (timer > 5)


            timer += Time.fixedDeltaTime;

            if (timer > spawnrate )
            {
                GameObject c = Instantiate(creep);
                c.GetComponent<WalkFollowPath>().pathListObject = creepNavPath.transform;
                creepCount++;
                timer = 0;

                //Finised wave?
                if (creepCount > waveSize)
                {
                    //End this wave
                    waveActive = false;
                    waveSize += sizeInc;
                    delayTimer = 0;
                    waveDelay -= delayDec;
                    waveDelay = Mathf.Max(waveDelay, 1);
                }

            }
        }
        else
        {
            //Between Waves time delay
            delayTimer += Time.fixedDeltaTime;

            //Finished wave delay?
            if (delayTimer > waveDelay)
            {
                //Activate next wave
                currentWave++;
                //delayTimer = 0;
                creepCount = 0;
                timer = 0;
                waveActive = true;
            }
        }
	}
}
