﻿using UnityEngine;
using UnityEngine.SceneManagement;
using System.Collections;

public class GameManager : MonoBehaviour {

    public int initialBaseHealth = 100;
    int baseHealth;
    GameObject uiManager;
    GameObject spawnManager;

    public int initialGold;
    public int gold;
    public int score;

    bool gameOverBool;

    // Use this for initialization
    void Start () {
        gameOverBool = false;
        baseHealth = initialBaseHealth;
        gold = initialGold;
        score = 0;

        uiManager = transform.Find("UI Manager").gameObject;
        spawnManager = transform.Find("Spawn Manager").gameObject;

    }

    // Update is called once per frame
    void Update () {
        if (!gameOverBool)
        {
            if (baseHealth <= 0)
            {
                uiManager.GetComponent<UIManager>().UpdateUiBaseHealth(baseHealth);
                GameOver();
            }
            else
            {
                uiManager.GetComponent<UIManager>().UpdateUiBaseHealth(baseHealth);
            }

            uiManager.GetComponent<UIManager>().UpdateUiGold(gold);
            uiManager.GetComponent<UIManager>().UpdateUiScore(score);

        }

        if (gameOverBool) {

            if (Input.GetMouseButtonDown(0)) {
                SceneManager.LoadScene("Title");

            }
        }
        if (Input.GetKeyDown(KeyCode.Escape))
        {
            SceneManager.LoadScene("Title");

        }


    }

    public void DamageBase(int damageValue) {
        baseHealth -= damageValue;

		SoundBank.currentInstance.PlayLoseLifeSound ();
    }

    public void ChangeGold(int value) {
        gold += value; 
    }

    public void ChangeScore(int value)
    {
        score += value;
    }
    public void GameOver() {

        gameOverBool = true;

        Destroy(spawnManager);

        uiManager.GetComponent<UIManager>().SetGameOver();


        Debug.Log("GameOver");
		StartCoroutine (ChangeScene ());
    }

	IEnumerator ChangeScene()
	{
		yield return new WaitForSeconds (4);
		SceneManager.LoadScene("Title");
	}
}
