﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WalkFollowPath : MonoBehaviour {

	public Transform pathListObject;
	public float moveSpeed = 12;

	int currentNodeNumber = 0;
	Transform currentTarget;

    public GameObject gameManager;

    public Transform destroyPrefab;
    public Transform damageSpawn;

    // Use this for initialization
    void Start () {
		if ( pathListObject != null && pathListObject.childCount > 0)
		{
			currentTarget = pathListObject.GetChild(currentNodeNumber).transform;			
		}

        gameManager = GameObject.Find("Game Manager");
        damageSpawn = GameObject.Find("Damage Spawn").transform;
    }
		
	// Update is called once per frame
	void Update () {

		//if ( IsOnTheGround() == true)
		{
			Vector3 currentPosition = transform.position;
			Vector3 targetPosition = currentTarget.position;
			targetPosition.y = currentPosition.y;

			transform.position = Vector3.MoveTowards(currentPosition, targetPosition, Time.deltaTime * moveSpeed);	
		}

	}

	void FindNextTarget()
	{
		currentNodeNumber++;
		if ( currentNodeNumber >= pathListObject.childCount)
		{
             currentNodeNumber = 0;

            // Damage Base Logic here - MAYBE MOVE SOMEWHERE ELSE

            Transform node = Instantiate(destroyPrefab);

            node.position = damageSpawn.position;
            Destroy(node.gameObject, 0.6f);

            gameManager.GetComponent<GameManager>().DamageBase(10);
            Destroy(transform.gameObject);
		}

		currentTarget = pathListObject.GetChild(currentNodeNumber).transform;
	}

	void OnTriggerEnter(Collider other)
	{
		if ( other.tag == "PathNode" && other.transform == currentTarget.transform)
		{
			FindNextTarget();
		}
	}


	public LayerMask groundLayer;
	public float groundCheckDistance = 1;
	bool IsOnTheGround()
	{

        // Not working for now

        bool result = Physics.Raycast(transform.position, Vector3.down, groundCheckDistance, groundLayer);
        RaycastHit[] rays = Physics.RaycastAll(transform.position, Vector3.down, groundCheckDistance, groundLayer);
		if (result)
		{
			return true;
		}

		return false;
	}
}
